﻿//
// BlankPage.xaml.h
// Declaration of the BlankPage.xaml class.
//

#pragma once

#include "DirectXPage.g.h"
#include "ZoomMapRenderer.h"
#include "BasicTimer.h"
#include "ViewParams.h"

namespace FastZoomMap
{
    /// <summary>
    /// A DirectX page that can be used on its own.  Note that it may not be used within a Frame.
    /// </summary>
    [Windows::Foundation::Metadata::WebHostHidden]
    public ref class DirectXPage sealed
    {
    private:
        Windows::Devices::Geolocation::Geolocator^ geolocator;

    public:
        DirectXPage();

        void SaveInternalState(Windows::Foundation::Collections::IPropertySet^ state);
        void LoadInternalState(Windows::Foundation::Collections::IPropertySet^ state);

    private:
        // From template
        void OnWindowSizeChanged(Windows::UI::Core::CoreWindow^ sender, Windows::UI::Core::WindowSizeChangedEventArgs^ args);
        void OnLogicalDpiChanged(Platform::Object^ sender);
        void OnOrientationChanged(Platform::Object^ sender);
        void OnDisplayContentsInvalidated(Platform::Object^ sender);
        void OnRendering(Object^ sender, Object^ args);

        Windows::Foundation::EventRegistrationToken m_eventToken;
        ZoomMapRenderer^ m_renderer;
        bool m_renderNeeded;
        BasicTimer^ m_timer;

        // Added to template
        void OnPageLoaded(Platform::Object^ sender, Windows::UI::Xaml::RoutedEventArgs^ args);
        Concurrency::task<ViewParams> GetViewParamsAsync(wchar_t* type);
        void OnSliderValueChanged(Platform::Object^ sender, Windows::UI::Xaml::Controls::Primitives::RangeBaseValueChangedEventArgs^ args);
    };
}
